#include "ruby-spml.h"

#ifdef IFORT
extern struct farray* w_spectrum_module_mp_nm_energyfromstreamfunc_w_(struct farray*, struct farray*);
extern struct farray* w_spectrum_module_mp_n_energyfromstreamfunc_w_(struct farray*, struct farray*);
extern struct farray* w_spectrum_module_mp_nm_enstrophyfromstreamfunc_w_(struct farray*, struct farray*);
extern struct farray* w_spectrum_module_mp_n_enstrophyfromstreamfunc_w_(struct farray*, struct farray*);
#endif
#ifdef GFORTRAN
extern struct farray* __w_spectrum_module_MOD_nm_energyfromstreamfunc_w(struct farray*, struct farray*);
extern struct farray* __w_spectrum_module_MOD_n_energyfromstreamfunc_w(struct farray*, struct farray*);
extern struct farray* __w_spectrum_module_MOD_nm_enstrophyfromstreamfunc_w(struct farray*, struct farray*);
extern struct farray* __w_spectrum_module_MOD_n_enstrophyfromstreamfunc_w(struct farray*, struct farray*);
#endif
#ifdef FFC32
asm ("w_spectrum_module_nm_energyfromstreamfunc_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_spectrum_module.nm_energyfromstreamfunc_w_");
asm ("  leave");
asm ("  ret");
asm ("w_spectrum_module_n_energyfromstreamfunc_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_spectrum_module.n_energyfromstreamfunc_w_");
asm ("  leave");
asm ("  ret");
asm ("w_spectrum_module_nm_enstrophyfromstreamfunc_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_spectrum_module.nm_enstrophyfromstreamfunc_w_");
asm ("  leave");
asm ("  ret");
asm ("w_spectrum_module_n_enstrophyfromstreamfunc_w_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call w_spectrum_module.n_enstrophyfromstreamfunc_w_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("w_spectrum_module_nm_energyfromstreamfunc_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_spectrum_module.nm_energyfromstreamfunc_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_spectrum_module_n_energyfromstreamfunc_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_spectrum_module.n_energyfromstreamfunc_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_spectrum_module_nm_enstrophyfromstreamfunc_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_spectrum_module.nm_enstrophyfromstreamfunc_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("w_spectrum_module_n_enstrophyfromstreamfunc_w_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call w_spectrum_module.n_enstrophyfromstreamfunc_w_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern struct farray* w_spectrum_module_nm_energyfromstreamfunc_w_(struct farray*, struct farray*);
extern struct farray* w_spectrum_module_n_energyfromstreamfunc_w_(struct farray*, struct farray*);
extern struct farray* w_spectrum_module_nm_enstrophyfromstreamfunc_w_(struct farray*, struct farray*);
extern struct farray* w_spectrum_module_n_enstrophyfromstreamfunc_w_(struct farray*, struct farray*);
#endif


static VALUE
rbspml_nm_EnergyFromStreamfunc_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_strfunc, out;
  struct farray* cw_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_strfunc);
  w_strfunc = na_cast_object(w_strfunc, NA_DFLOAT);
  cw_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(w_strfunc)->shape[i];
    offset += j;
  }
  cw_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cw_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cw_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cw_strfunc->rank = 1;
#elif defined GFORTRAN
{
  cw_strfunc->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cw_strfunc->total = NA_STRUCT(w_strfunc)->total;
  cw_strfunc->total_byte = cw_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(w_strfunc)->shape[i];
    fs = (struct fshape*)(cw_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cw_strfunc->array = NA_PTR_TYPE(w_strfunc, void*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (-NUM2INT(rb_funcall(self,rb_intern("nm"),0))) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_spectrum_module_mp_nm_energyfromstreamfunc_w_(cout, cw_strfunc);
#elif defined GFORTRAN
  __w_spectrum_module_MOD_nm_energyfromstreamfunc_w(cout, cw_strfunc);
#elif defined(FFC32) || defined(FFC64)
  w_spectrum_module_nm_energyfromstreamfunc_w_(cout, cw_strfunc);
#endif

  free(cw_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_n_EnergyFromStreamfunc_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_strfunc, out;
  struct farray* cw_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_strfunc);
  w_strfunc = na_cast_object(w_strfunc, NA_DFLOAT);
  cw_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(w_strfunc)->shape[i];
    offset += j;
  }
  cw_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cw_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cw_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cw_strfunc->rank = 1;
#elif defined GFORTRAN
{
  cw_strfunc->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cw_strfunc->total = NA_STRUCT(w_strfunc)->total;
  cw_strfunc->total_byte = cw_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(w_strfunc)->shape[i];
    fs = (struct fshape*)(cw_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cw_strfunc->array = NA_PTR_TYPE(w_strfunc, void*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_spectrum_module_mp_n_energyfromstreamfunc_w_(cout, cw_strfunc);
#elif defined GFORTRAN
  __w_spectrum_module_MOD_n_energyfromstreamfunc_w(cout, cw_strfunc);
#elif defined(FFC32) || defined(FFC64)
  w_spectrum_module_n_energyfromstreamfunc_w_(cout, cw_strfunc);
#endif

  free(cw_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_nm_EnstrophyFromStreamfunc_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_strfunc, out;
  struct farray* cw_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_strfunc);
  w_strfunc = na_cast_object(w_strfunc, NA_DFLOAT);
  cw_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(w_strfunc)->shape[i];
    offset += j;
  }
  cw_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cw_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cw_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cw_strfunc->rank = 1;
#elif defined GFORTRAN
{
  cw_strfunc->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cw_strfunc->total = NA_STRUCT(w_strfunc)->total;
  cw_strfunc->total_byte = cw_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(w_strfunc)->shape[i];
    fs = (struct fshape*)(cw_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cw_strfunc->array = NA_PTR_TYPE(w_strfunc, void*);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (-NUM2INT(rb_funcall(self,rb_intern("nm"),0))) + 1;
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_spectrum_module_mp_nm_enstrophyfromstreamfunc_w_(cout, cw_strfunc);
#elif defined GFORTRAN
  __w_spectrum_module_MOD_nm_enstrophyfromstreamfunc_w(cout, cw_strfunc);
#elif defined(FFC32) || defined(FFC64)
  w_spectrum_module_nm_enstrophyfromstreamfunc_w_(cout, cw_strfunc);
#endif

  free(cw_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_n_EnstrophyFromStreamfunc_w(int argc, VALUE *argv, VALUE self)
{
  VALUE w_strfunc, out;
  struct farray* cw_strfunc;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &w_strfunc);
  w_strfunc = na_cast_object(w_strfunc, NA_DFLOAT);
  cw_strfunc = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(w_strfunc)->shape[i];
    offset += j;
  }
  cw_strfunc->offset = -offset;
}
#endif
#if defined IFORT
  cw_strfunc->vsize = sizeof(double);
{
  long type = 10;
  cw_strfunc->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cw_strfunc->rank = 1;
#elif defined GFORTRAN
{
  cw_strfunc->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cw_strfunc->total = NA_STRUCT(w_strfunc)->total;
  cw_strfunc->total_byte = cw_strfunc->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(w_strfunc)->shape[i];
    fs = (struct fshape*)(cw_strfunc+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cw_strfunc->array = NA_PTR_TYPE(w_strfunc, void*);
{
  int shape[1];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  w_spectrum_module_mp_n_enstrophyfromstreamfunc_w_(cout, cw_strfunc);
#elif defined GFORTRAN
  __w_spectrum_module_MOD_n_enstrophyfromstreamfunc_w(cout, cw_strfunc);
#elif defined(FFC32) || defined(FFC64)
  w_spectrum_module_n_enstrophyfromstreamfunc_w_(cout, cw_strfunc);
#endif

  free(cw_strfunc);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}


void init_w_spectrum_module(VALUE mSPML)
{
  VALUE mW_SPECTRUM;

  mW_SPECTRUM = rb_define_module_under(mSPML, "W_SPECTRUM");

  rb_define_module_function(mW_SPECTRUM, "nm_EnergyFromStreamfunc_w", rbspml_nm_EnergyFromStreamfunc_w, -1);
  rb_define_method(mW_SPECTRUM, "nm_EnergyFromStreamfunc_w", rbspml_nm_EnergyFromStreamfunc_w, -1);
  rb_define_module_function(mW_SPECTRUM, "n_EnergyFromStreamfunc_w", rbspml_n_EnergyFromStreamfunc_w, -1);
  rb_define_method(mW_SPECTRUM, "n_EnergyFromStreamfunc_w", rbspml_n_EnergyFromStreamfunc_w, -1);
  rb_define_module_function(mW_SPECTRUM, "nm_EnstrophyFromStreamfunc_w", rbspml_nm_EnstrophyFromStreamfunc_w, -1);
  rb_define_method(mW_SPECTRUM, "nm_EnstrophyFromStreamfunc_w", rbspml_nm_EnstrophyFromStreamfunc_w, -1);
  rb_define_module_function(mW_SPECTRUM, "n_EnstrophyFromStreamfunc_w", rbspml_n_EnstrophyFromStreamfunc_w, -1);
  rb_define_method(mW_SPECTRUM, "n_EnstrophyFromStreamfunc_w", rbspml_n_EnstrophyFromStreamfunc_w, -1);
}
