#include "ruby-spml.h"

#ifdef IFORT
extern void wa_module_mp_wa_initial_(int*, int*, int*, int*, int*);
#endif
#ifdef GFORTRAN
extern void __wa_module_MOD_wa_initial(int*, int*, int*, int*, int*);
#endif
#ifdef FFC32
asm ("wa_module_wa_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 24(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_module.wa_initial_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("wa_module_wa_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_module.wa_initial_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern void wa_module_wa_initial_(int*, int*, int*, int*, int*);
#endif


static VALUE
rbspml_wa_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE n_in, i_in, j_in, k_in, np_in;
  int cn_in;
  int ci_in;
  int cj_in;
  int ck_in;
  int cnp_in;

  rb_scan_args(argc, argv, "41", &n_in, &i_in, &j_in, &k_in, &np_in);
  cn_in = NUM2INT(n_in);
  ci_in = NUM2INT(i_in);
  cj_in = NUM2INT(j_in);
  ck_in = NUM2INT(k_in);
  if ( np_in != Qnil )
    cnp_in = NUM2INT(np_in);

#if defined IFORT
  wa_module_mp_wa_initial_(&cn_in, &ci_in, &cj_in, &ck_in, np_in==Qnil ? NULL : &cnp_in);
#elif defined GFORTRAN
  __wa_module_MOD_wa_initial(&cn_in, &ci_in, &cj_in, &ck_in, np_in==Qnil ? NULL : &cnp_in);
#elif defined(FFC32) || defined(FFC64)
  wa_module_wa_initial_(&cn_in, &ci_in, &cj_in, &ck_in, np_in==Qnil ? NULL : &cnp_in);
#endif

  return Qnil;
}


void init_wa_module(VALUE mSPML)
{
  VALUE mWA;

  mWA = rb_define_module_under(mSPML, "WA");

  rb_define_module_function(mWA, "initial", rbspml_wa_Initial, -1);
  rb_define_method(mWA, "initial", rbspml_wa_Initial, -1);
}
