#include "ruby-spml.h"

#ifdef IFORT
extern double* l_module_mp_y_lat_;
extern double* l_module_mp_y_lat_weight_;
extern void l_module_mp_l_initial_(int*, int*);
extern struct farray* l_module_mp_y_l_(struct farray*, double*);
extern struct farray* l_module_mp_l_y_(struct farray*, double*);
extern struct farray* l_module_mp_l_lapla_l_(struct farray*, double*);
extern struct farray* l_module_mp_l_laplainv_l_(struct farray*, double*);
extern struct farray* l_module_mp_y_gradlat_l_(struct farray*, double*);
extern struct farray* l_module_mp_l_divlat_y_(struct farray*, double*);
extern struct farray* l_module_mp_y_gradmu_l_(struct farray*, double*);
extern struct farray* l_module_mp_l_divmu_y_(struct farray*, double*);
extern double l_module_mp_intlat_y_(double*);
extern double l_module_mp_avrlat_y_(double*);
extern double l_module_mp_interpolate_l_(double*, double*);
#endif
#ifdef GFORTRAN
extern double* __l_module_MOD_y_lat;
extern double* __l_module_MOD_y_lat_weight;
extern void __l_module_MOD_l_initial(int*, int*);
extern struct farray* __l_module_MOD_y_l(struct farray*, double*);
extern struct farray* __l_module_MOD_l_y(struct farray*, double*);
extern struct farray* __l_module_MOD_l_lapla_l(struct farray*, double*);
extern struct farray* __l_module_MOD_l_laplainv_l(struct farray*, double*);
extern struct farray* __l_module_MOD_y_gradlat_l(struct farray*, double*);
extern struct farray* __l_module_MOD_l_divlat_y(struct farray*, double*);
extern struct farray* __l_module_MOD_y_gradmu_l(struct farray*, double*);
extern struct farray* __l_module_MOD_l_divmu_y(struct farray*, double*);
extern double __l_module_MOD_intlat_y(double*);
extern double __l_module_MOD_avrlat_y(double*);
extern double __l_module_MOD_interpolate_l(double*, double*);
#endif
#ifdef FFC32
asm ("l_module_y_lat_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.l_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_lat_weight_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.l_module_+28, %eax");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.l_initial_");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_l_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.y_l_");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.l_y_");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_lapla_l_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.l_lapla_l_");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_laplainv_l_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.l_laplainv_l_");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_gradlat_l_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.y_gradlat_l_");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_divlat_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.l_divlat_y_");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_gradmu_l_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.y_gradmu_l_");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_divmu_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.l_divmu_y_");
asm ("  leave");
asm ("  ret");
asm ("l_module_intlat_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.intlat_y_");
asm ("  leave");
asm ("  ret");
asm ("l_module_avrlat_y_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.avrlat_y_");
asm ("  leave");
asm ("  ret");
asm ("l_module_interpolate_l_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call l_module.interpolate_l_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("l_module_y_lat_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.l_module_@GOTPCREL(%rip), %rax");
asm ("  movq 0(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_lat_weight_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.l_module_@GOTPCREL(%rip), %rax");
asm ("  movq 56(%rax), %r10");
asm ("  movq (%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.l_initial_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_l_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.y_l_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.l_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_lapla_l_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.l_lapla_l_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_laplainv_l_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.l_laplainv_l_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_gradlat_l_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.y_gradlat_l_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_divlat_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.l_divlat_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_y_gradmu_l_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.y_gradmu_l_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_l_divmu_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.l_divmu_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_intlat_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.intlat_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_avrlat_y_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.avrlat_y_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("l_module_interpolate_l_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call l_module.interpolate_l_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern double* l_module_y_lat_();
extern double* l_module_y_lat_weight_();
extern void l_module_l_initial_(int*, int*);
extern struct farray* l_module_y_l_(struct farray*, double*);
extern struct farray* l_module_l_y_(struct farray*, double*);
extern struct farray* l_module_l_lapla_l_(struct farray*, double*);
extern struct farray* l_module_l_laplainv_l_(struct farray*, double*);
extern struct farray* l_module_y_gradlat_l_(struct farray*, double*);
extern struct farray* l_module_l_divlat_y_(struct farray*, double*);
extern struct farray* l_module_y_gradmu_l_(struct farray*, double*);
extern struct farray* l_module_l_divmu_y_(struct farray*, double*);
extern double l_module_intlat_y_(double*);
extern double l_module_avrlat_y_(double*);
extern double l_module_interpolate_l_(double*, double*);
#endif


static int jm = 32;
static int nm = 21;


static VALUE
rbspml_y_Lat(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)l_module_mp_y_lat_;
#elif defined GFORTRAN
  cout = (double*)__l_module_MOD_y_lat;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)l_module_y_lat_();
#endif

{
  int shape[1];
  shape[0] = jm;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_y_Lat_Weight(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  double* cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = (double*)l_module_mp_y_lat_weight_;
#elif defined GFORTRAN
  cout = (double*)__l_module_MOD_y_lat_weight;
#elif defined(FFC32) || defined(FFC64)
  cout = (double*)l_module_y_lat_weight_();
#endif

{
  int shape[1];
  shape[0] = jm;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = cout[i];
};
  return out;
}

static VALUE
rbspml_l_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE n_in, j_in;
  int cn_in;
  int cj_in;

  rb_scan_args(argc, argv, "20", &n_in, &j_in);
  cn_in = NUM2INT(n_in);
  cj_in = NUM2INT(j_in);
  jm = cj_in;
  nm = cn_in;

#if defined IFORT
  l_module_mp_l_initial_(&cn_in, &cj_in);
#elif defined GFORTRAN
  __l_module_MOD_l_initial(&cn_in, &cj_in);
#elif defined(FFC32) || defined(FFC64)
  l_module_l_initial_(&cn_in, &cj_in);
#endif

  return Qnil;
}

static VALUE
rbspml_y_l(int argc, VALUE *argv, VALUE self)
{
  VALUE l_data, out;
  double* cl_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &l_data);
  l_data = na_cast_object(l_data, NA_DFLOAT);
  cl_data = NA_PTR_TYPE(l_data, double*);
{
  int shape[1];
  shape[0] = (jm) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_y_l_(cout, cl_data);
#elif defined GFORTRAN
  __l_module_MOD_y_l(cout, cl_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_y_l_(cout, cl_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_l_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y_data, out;
  double* cy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &y_data);
  y_data = na_cast_object(y_data, NA_DFLOAT);
  cy_data = NA_PTR_TYPE(y_data, double*);
{
  int shape[1];
  shape[0] = (nm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_l_y_(cout, cy_data);
#elif defined GFORTRAN
  __l_module_MOD_l_y(cout, cy_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_l_y_(cout, cy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_l_Lapla_l(int argc, VALUE *argv, VALUE self)
{
  VALUE l_data, out;
  double* cl_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &l_data);
  l_data = na_cast_object(l_data, NA_DFLOAT);
  cl_data = NA_PTR_TYPE(l_data, double*);
{
  int shape[1];
  shape[0] = (nm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_l_lapla_l_(cout, cl_data);
#elif defined GFORTRAN
  __l_module_MOD_l_lapla_l(cout, cl_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_l_lapla_l_(cout, cl_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_l_LaplaInv_l(int argc, VALUE *argv, VALUE self)
{
  VALUE l_data, out;
  double* cl_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &l_data);
  l_data = na_cast_object(l_data, NA_DFLOAT);
  cl_data = NA_PTR_TYPE(l_data, double*);
{
  int shape[1];
  shape[0] = (nm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_l_laplainv_l_(cout, cl_data);
#elif defined GFORTRAN
  __l_module_MOD_l_laplainv_l(cout, cl_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_l_laplainv_l_(cout, cl_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_y_GradLat_l(int argc, VALUE *argv, VALUE self)
{
  VALUE l_data, out;
  double* cl_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &l_data);
  l_data = na_cast_object(l_data, NA_DFLOAT);
  cl_data = NA_PTR_TYPE(l_data, double*);
{
  int shape[1];
  shape[0] = (jm) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_y_gradlat_l_(cout, cl_data);
#elif defined GFORTRAN
  __l_module_MOD_y_gradlat_l(cout, cl_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_y_gradlat_l_(cout, cl_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_l_DivLat_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y_data, out;
  double* cy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &y_data);
  y_data = na_cast_object(y_data, NA_DFLOAT);
  cy_data = NA_PTR_TYPE(y_data, double*);
{
  int shape[1];
  shape[0] = (nm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_l_divlat_y_(cout, cy_data);
#elif defined GFORTRAN
  __l_module_MOD_l_divlat_y(cout, cy_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_l_divlat_y_(cout, cy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_y_GradMu_l(int argc, VALUE *argv, VALUE self)
{
  VALUE l_data, out;
  double* cl_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &l_data);
  l_data = na_cast_object(l_data, NA_DFLOAT);
  cl_data = NA_PTR_TYPE(l_data, double*);
{
  int shape[1];
  shape[0] = (jm) - (1) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_y_gradmu_l_(cout, cl_data);
#elif defined GFORTRAN
  __l_module_MOD_y_gradmu_l(cout, cl_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_y_gradmu_l_(cout, cl_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_l_DivMu_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y_data, out;
  double* cy_data;
  struct farray* cout;

  rb_scan_args(argc, argv, "10", &y_data);
  y_data = na_cast_object(y_data, NA_DFLOAT);
  cy_data = NA_PTR_TYPE(y_data, double*);
{
  int shape[1];
  shape[0] = (nm) - (0) + 1;
  out = na_make_object(NA_DFLOAT, 1, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*1);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<0;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 1;
#elif defined GFORTRAN
{
  cout->flag = (1 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<1;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  l_module_mp_l_divmu_y_(cout, cy_data);
#elif defined GFORTRAN
  __l_module_MOD_l_divmu_y(cout, cy_data);
#elif defined(FFC32) || defined(FFC64)
  l_module_l_divmu_y_(cout, cy_data);
#endif

#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_IntLat_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y_data, out;
  double* cy_data;
  double cout;

  rb_scan_args(argc, argv, "10", &y_data);
  y_data = na_cast_object(y_data, NA_DFLOAT);
  cy_data = NA_PTR_TYPE(y_data, double*);

#if defined IFORT
  cout = l_module_mp_intlat_y_(cy_data);
#elif defined GFORTRAN
  cout = __l_module_MOD_intlat_y(cy_data);
#elif defined(FFC32) || defined(FFC64)
  cout = l_module_intlat_y_(cy_data);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_AvrLat_y(int argc, VALUE *argv, VALUE self)
{
  VALUE y_data, out;
  double* cy_data;
  double cout;

  rb_scan_args(argc, argv, "10", &y_data);
  y_data = na_cast_object(y_data, NA_DFLOAT);
  cy_data = NA_PTR_TYPE(y_data, double*);

#if defined IFORT
  cout = l_module_mp_avrlat_y_(cy_data);
#elif defined GFORTRAN
  cout = __l_module_MOD_avrlat_y(cy_data);
#elif defined(FFC32) || defined(FFC64)
  cout = l_module_avrlat_y_(cy_data);
#endif

  out = rb_float_new(cout);
  return out;
}

static VALUE
rbspml_Interpolate_l(int argc, VALUE *argv, VALUE self)
{
  VALUE l_data, alat, out;
  double* cl_data;
  double calat;
  double cout;

  rb_scan_args(argc, argv, "20", &l_data, &alat);
  l_data = na_cast_object(l_data, NA_DFLOAT);
  cl_data = NA_PTR_TYPE(l_data, double*);
  calat = NUM2DBL(alat);

#if defined IFORT
  cout = l_module_mp_interpolate_l_(cl_data, &calat);
#elif defined GFORTRAN
  cout = __l_module_MOD_interpolate_l(cl_data, &calat);
#elif defined(FFC32) || defined(FFC64)
  cout = l_module_interpolate_l_(cl_data, &calat);
#endif

  out = rb_float_new(cout);
  return out;
}


void init_l_module(VALUE mSPML)
{
  VALUE mL;

  mL = rb_define_module_under(mSPML, "L");

  rb_define_module_function(mL, "y_Lat", rbspml_y_Lat, -1);
  rb_define_method(mL, "y_Lat", rbspml_y_Lat, -1);
  rb_define_module_function(mL, "y_Lat_Weight", rbspml_y_Lat_Weight, -1);
  rb_define_method(mL, "y_Lat_Weight", rbspml_y_Lat_Weight, -1);
  rb_define_module_function(mL, "initial", rbspml_l_Initial, -1);
  rb_define_method(mL, "initial", rbspml_l_Initial, -1);
  rb_define_module_function(mL, "y_l", rbspml_y_l, -1);
  rb_define_method(mL, "y_l", rbspml_y_l, -1);
  rb_define_module_function(mL, "l_y", rbspml_l_y, -1);
  rb_define_method(mL, "l_y", rbspml_l_y, -1);
  rb_define_module_function(mL, "l_Lapla_l", rbspml_l_Lapla_l, -1);
  rb_define_method(mL, "l_Lapla_l", rbspml_l_Lapla_l, -1);
  rb_define_module_function(mL, "l_LaplaInv_l", rbspml_l_LaplaInv_l, -1);
  rb_define_method(mL, "l_LaplaInv_l", rbspml_l_LaplaInv_l, -1);
  rb_define_module_function(mL, "y_GradLat_l", rbspml_y_GradLat_l, -1);
  rb_define_method(mL, "y_GradLat_l", rbspml_y_GradLat_l, -1);
  rb_define_module_function(mL, "l_DivLat_y", rbspml_l_DivLat_y, -1);
  rb_define_method(mL, "l_DivLat_y", rbspml_l_DivLat_y, -1);
  rb_define_module_function(mL, "y_GradMu_l", rbspml_y_GradMu_l, -1);
  rb_define_method(mL, "y_GradMu_l", rbspml_y_GradMu_l, -1);
  rb_define_module_function(mL, "l_DivMu_y", rbspml_l_DivMu_y, -1);
  rb_define_method(mL, "l_DivMu_y", rbspml_l_DivMu_y, -1);
  rb_define_module_function(mL, "IntLat_y", rbspml_IntLat_y, -1);
  rb_define_method(mL, "IntLat_y", rbspml_IntLat_y, -1);
  rb_define_module_function(mL, "AvrLat_y", rbspml_AvrLat_y, -1);
  rb_define_method(mL, "AvrLat_y", rbspml_AvrLat_y, -1);
  rb_define_module_function(mL, "Interpolate_l", rbspml_Interpolate_l, -1);
  rb_define_method(mL, "Interpolate_l", rbspml_Interpolate_l, -1);
}
