#include <stdio.h>

void __test_MOD_func(long *x, long *y)
{
  int i, n;
  unsigned int ndim;
  unsigned int shape[5];
  int j, offset;

  i = 0; printf("%2d, %20s: %16lx, %16lx\n", i, "address", x[i], y[i]);
  i ++; printf("%2d, %20s: %16ld, %16ld\n", i, "offset?", x[i], y[i]);
  i ++; printf("%2d, %20s: %8d, %8d\n", i, "rank", x[i]&0x7, y[i]&0x7);
  ndim = x[i]&0x7;
  printf("%2d, %20s: %8x, %8x\n", i, "flag", (x[i]>>4)&3, (y[i]>>4)&3);
  printf("%2d, %20s: %8d, %8d\n", i, "value size", (x[i]>>6), (y[i]>>6));


  
  j = 1;
  offset = 1;
  for (n=0; n<ndim; n++) {
    i ++; printf("%2d, %d%20s: %16lx, %16lx\n", i, n, "dim step", x[i], y[i]);
    i ++; printf("%2d, %d%20s: %16lx, %16lx\n", i, n, "dim start", x[i], y[i]);
    i ++; printf("%2d, %d%20s: %16lx, %16lx\n", i, n, "dim end", x[i], y[i]);
    shape[n] = x[i] - x[i-1] + 1;
    if (n<ndim-1) {
      j *= shape[n];
      offset += j;
    }
  }
  printf("offset = %d\n", offset);
}

void sub_(double *x)
{
  printf("address = %lx\n", x);
}
