#include <stdio.h>

void test_mp_func_(long *y, long *x)
{
  int i, n;
  unsigned long ndim;

  i = 0; printf("%2d %20s: %16lx, %16lx\n", i, "address", x[i], y[i]);
  i++; printf("%2d %20s: %16d, %16d\n", i, "val size", x[i], y[i]);
  i++; printf("%2d %20s: %16ld, %16ld\n", i, "offset?", x[i], y[i]);
  i++; printf("%2d %20s: %16lx, %16lx\n", i, "flags?", x[i], y[i]);
  i++; printf("%2d %20s: %16d, %16d\n", i, "rank", x[i], y[i]);
  i++; printf("%2d %20s: %16lx, %16lx\n", i, "reserved1", x[i], y[i]);
  ndim = x[4];

  for (n=0; n<ndim; n++) {
    i++; printf("%2d %d%20s: %16d, %16d\n", i, n, "dim size", x[i], y[i]);
    i++; printf("%2d %d%20s: %16d, %16d\n", i, n, "dim offset", x[i], y[i]);
    i++; printf("%2d %20s: %16lx, %16lx\n", i, "?", x[i], y[i]);
  }

}

void sub_(double *x)
{
  int i;
  printf("sizeof(long)=%d, sizeof(void*)=%d\n", sizeof(long), sizeof(void*));
  printf("address is %lx\n", x);
  for (i=0; i<8; i++)
    printf("%f, ", x[i]);
  printf("\n");
}
