#include "ruby-spml.h"

#ifdef IFORT
extern int wa_base_module_mp_km_;
extern void wa_base_module_mp_wa_base_initial_(int*);
extern struct farray* wa_base_module_mp_xya_wa_(struct farray*, struct farray*, int*, int*);
extern struct farray* wa_base_module_mp_wa_xya_(struct farray*, struct farray*, int*, int*);
#endif
#ifdef GFORTRAN
extern int __wa_base_module_MOD_km;
extern void __wa_base_module_MOD_wa_base_initial(int*);
extern struct farray* __wa_base_module_MOD_xya_wa(struct farray*, struct farray*, int*, int*);
extern struct farray* __wa_base_module_MOD_wa_xya(struct farray*, struct farray*, int*, int*);
#endif
#ifdef FFC32
asm ("wa_base_module_km_:");
asm ("  pushl %ebp");
asm ("  movl %esp, %ebp");
asm ("  movl MODULE.wa_base_module_+0, %eax");
asm ("  leave");
asm ("  ret");
asm ("wa_base_module_wa_base_initial_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_base_module.wa_base_initial_");
asm ("  leave");
asm ("  ret");
asm ("wa_base_module_xya_wa_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_base_module.xya_wa_");
asm ("  leave");
asm ("  ret");
asm ("wa_base_module_wa_xya_:");
asm ("  pushl %ebp");
asm ("  movl %esp,%ebp");
asm ("  movl 20(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 16(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 12(%ebp), %eax");
asm ("  pushl %eax");
asm ("  movl 8(%ebp), %eax");
asm ("  pushl %eax");
asm ("  call wa_base_module.wa_xya_");
asm ("  leave");
asm ("  ret");
#endif
#ifdef FFC64
asm ("wa_base_module_km_:");
asm ("  push %rbp");
asm ("  movq %rsp, %rbp");
asm ("  leaq MODULE.wa_base_module_@GOTPCREL(%rip), %r10");
asm ("  leaq 0(%r10), %rax");
asm ("  leave");
asm ("  ret");
asm ("wa_base_module_wa_base_initial_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_base_module.wa_base_initial_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wa_base_module_xya_wa_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_base_module.xya_wa_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
asm ("wa_base_module_wa_xya_:");
asm ("  push %rbp");
asm ("  movq %rsp,%rbp");
asm ("  subq $16,%rsp");
asm ("  call wa_base_module.wa_xya_@PLT");
asm ("  xorq %rax,%rax");
asm ("  addq $16,%rsp");
asm ("  leave");
asm ("  ret");
#endif
#if defined(FFC32) || defined(FFC64)
extern int wa_base_module_km_();
extern void wa_base_module_wa_base_initial_(int*);
extern struct farray* wa_base_module_xya_wa_(struct farray*, struct farray*, int*, int*);
extern struct farray* wa_base_module_wa_xya_(struct farray*, struct farray*, int*, int*);
#endif


static VALUE
rbspml_km(int argc, VALUE *argv, VALUE self)
{
  VALUE out;
  int cout;

  rb_scan_args(argc, argv, "00");

#if defined IFORT
  cout = wa_base_module_mp_km_;
#elif defined GFORTRAN
  cout = __wa_base_module_MOD_km;
#elif defined(FFC32) || defined(FFC64)
  cout = wa_base_module_km_();
#endif

  out = INT2NUM(cout);
  return out;
}

static VALUE
rbspml_wa_base_Initial(int argc, VALUE *argv, VALUE self)
{
  VALUE k_in;
  int ck_in;

  rb_scan_args(argc, argv, "10", &k_in);
  ck_in = NUM2INT(k_in);

#if defined IFORT
  wa_base_module_mp_wa_base_initial_(&ck_in);
#elif defined GFORTRAN
  __wa_base_module_MOD_wa_base_initial(&ck_in);
#elif defined(FFC32) || defined(FFC64)
  wa_base_module_wa_base_initial_(&ck_in);
#endif

  return Qnil;
}

static VALUE
rbspml_xya_wa(int argc, VALUE *argv, VALUE self)
{
  VALUE wa_data, ipow, iflag, out;
  struct farray* cwa_data;
  int cipow;
  int ciflag;
  struct farray* cout;

  rb_scan_args(argc, argv, "12", &wa_data, &ipow, &iflag);
  wa_data = na_cast_object(wa_data, NA_DFLOAT);
  cwa_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(wa_data)->shape[i];
    offset += j;
  }
  cwa_data->offset = -offset;
}
#endif
#if defined IFORT
  cwa_data->vsize = sizeof(double);
{
  long type = 10;
  cwa_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cwa_data->rank = 2;
#elif defined GFORTRAN
{
  cwa_data->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cwa_data->total = NA_STRUCT(wa_data)->total;
  cwa_data->total_byte = cwa_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(wa_data)->shape[i];
    fs = (struct fshape*)(cwa_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cwa_data->array = NA_PTR_TYPE(wa_data, void*);
  if ( ipow != Qnil )
    cipow = NUM2INT(ipow);
  if ( iflag != Qnil )
    ciflag = NUM2INT(iflag);
{
  int shape[3];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("im"),0))-1) - (0) + 1;
  shape[1] = (NUM2INT(rb_funcall(self,rb_intern("jm"),0))) - (1) + 1;
  shape[2] = (NA_STRUCT(wa_data)->shape[2]);
  out = na_make_object(NA_DFLOAT, 3, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*3);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<2;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 3;
#elif defined GFORTRAN
{
  cout->flag = (3 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<3;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_base_module_mp_xya_wa_(cout, cwa_data, ipow==Qnil ? NULL : &cipow, iflag==Qnil ? NULL : &ciflag);
#elif defined GFORTRAN
  __wa_base_module_MOD_xya_wa(cout, cwa_data, ipow==Qnil ? NULL : &cipow, iflag==Qnil ? NULL : &ciflag);
#elif defined(FFC32) || defined(FFC64)
  wa_base_module_xya_wa_(cout, cwa_data, ipow==Qnil ? NULL : &cipow, iflag==Qnil ? NULL : &ciflag);
#endif

  free(cwa_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}

static VALUE
rbspml_wa_xya(int argc, VALUE *argv, VALUE self)
{
  VALUE xya_data, ipow, iflag, out;
  struct farray* cxya_data;
  int cipow;
  int ciflag;
  struct farray* cout;

  rb_scan_args(argc, argv, "12", &xya_data, &ipow, &iflag);
  xya_data = na_cast_object(xya_data, NA_DFLOAT);
  cxya_data = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*3);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<2;i++) {
    j = j*NA_STRUCT(xya_data)->shape[i];
    offset += j;
  }
  cxya_data->offset = -offset;
}
#endif
#if defined IFORT
  cxya_data->vsize = sizeof(double);
{
  long type = 10;
  cxya_data->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cxya_data->rank = 3;
#elif defined GFORTRAN
{
  cxya_data->flag = (3 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cxya_data->total = NA_STRUCT(xya_data)->total;
  cxya_data->total_byte = cxya_data->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<3;i++) {
    len = NA_STRUCT(xya_data)->shape[i];
    fs = (struct fshape*)(cxya_data+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cxya_data->array = NA_PTR_TYPE(xya_data, void*);
  if ( ipow != Qnil )
    cipow = NUM2INT(ipow);
  if ( iflag != Qnil )
    ciflag = NUM2INT(iflag);
{
  int shape[2];
  shape[0] = (NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1)*(NUM2INT(rb_funcall(self,rb_intern("nm"),0))+1);
  shape[1] = (NA_STRUCT(xya_data)->shape[3]);
  out = na_make_object(NA_DFLOAT, 2, shape, cNArray);
  cout = (struct farray*) xmalloc(sizeof(struct farray)+sizeof(struct fshape)*2);
#if defined(IFORT) || defined(GFORTRAN)
{
  int i,j=1,offset=1;
  for (i=0;i<1;i++) {
    j = j*NA_STRUCT(out)->shape[i];
    offset += j;
  }
  cout->offset = -offset;
}
#endif
#if defined IFORT
  cout->vsize = sizeof(double);
{
  long type = 10;
  cout->type = ((type<<(sizeof(void*)*6)) | 1);
}
  cout->rank = 2;
#elif defined GFORTRAN
{
  cout->flag = (2 | (1<<4) | (sizeof(double)<<6));
}
#elif defined(FFC32) || defined(FFC64)
  cout->total = NA_STRUCT(out)->total;
  cout->total_byte = cout->total*sizeof(double);
#endif
{
  int step=1, len, i;
  struct fshape* fs;
  for (i=0;i<2;i++) {
    len = NA_STRUCT(out)->shape[i];
    fs = (struct fshape*)(cout+1)+i;
#if defined(IFORT) || defined(FFC32) || defined(FFC64)
    fs->step = 8*step;
    fs->length = len;
    fs->flag = 1;
#endif
#if defined(FFC32) || defined(FFC64)
    fs->length2 = len;
#endif
#ifdef GFORTRAN
    fs->step = step;
    fs->start = 1;
    fs->end = len;
#endif
    step *= len;
  }
}

  cout->array = NA_PTR_TYPE(out, void*);
};

#if defined IFORT
  wa_base_module_mp_wa_xya_(cout, cxya_data, ipow==Qnil ? NULL : &cipow, iflag==Qnil ? NULL : &ciflag);
#elif defined GFORTRAN
  __wa_base_module_MOD_wa_xya(cout, cxya_data, ipow==Qnil ? NULL : &cipow, iflag==Qnil ? NULL : &ciflag);
#elif defined(FFC32) || defined(FFC64)
  wa_base_module_wa_xya_(cout, cxya_data, ipow==Qnil ? NULL : &cipow, iflag==Qnil ? NULL : &ciflag);
#endif

  free(cxya_data);
#if defined(FFC32) || defined(FFC64)
{
  double* cnout = NA_PTR_TYPE(out,double*);
  int i;
  for (i=0;i<NA_TOTAL(out);i++)
    cnout[i] = ((double*)cout->array)[i];
}
#endif
  free(cout);
  return out;
}


void init_wa_base_module(VALUE mSPML)
{
  VALUE mWA_BASE;

  mWA_BASE = rb_define_module_under(mSPML, "WA_BASE");

  rb_define_module_function(mWA_BASE, "km", rbspml_km, -1);
  rb_define_method(mWA_BASE, "km", rbspml_km, -1);
  rb_define_module_function(mWA_BASE, "initial", rbspml_wa_base_Initial, -1);
  rb_define_method(mWA_BASE, "initial", rbspml_wa_base_Initial, -1);
  rb_define_module_function(mWA_BASE, "xya_wa", rbspml_xya_wa, -1);
  rb_define_method(mWA_BASE, "xya_wa", rbspml_xya_wa, -1);
  rb_define_module_function(mWA_BASE, "wa_xya", rbspml_wa_xya, -1);
  rb_define_method(mWA_BASE, "wa_xya", rbspml_wa_xya, -1);
}
